/*********************************************************************
 *
 *                Microchip USB C18 Firmware Version 1.0
 *
 * This file is generated by Microchip USB Wizard Version 1.0, 2004
 *********************************************************************
 * FileName:        usbdsc.c
 * Dependencies:    See INCLUDES section below
 * Processor:       PIC18
 * Compiler:        C18 2.30.01+
 * Company:         Microchip Technology, Inc.
 *
 * Software License Agreement
 *
 * The software supplied herewith by Microchip Technology Incorporated
 * (the CompanyE for its PICmicro Microcontroller is intended and
 * supplied to you, the Companys customer, for use solely and
 * exclusively on Microchip PICmicro Microcontroller products. The
 * software is owned by the Company and/or its supplier, and is
 * protected under applicable copyright laws. All rights are reserved.
 * Any use in violation of the foregoing restrictions may subject the
 * user to criminal sanctions under applicable laws, as well as to
 * civil liability for the breach of the terms and conditions of this
 * license.
 *
 * THIS SOFTWARE IS PROVIDED IN AN AS ISECONDITION. NO WARRANTIES,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 ********************************************************************/

/*********************************************************************
 * Descriptor specific type definitions are defined in:
 * system\usb\usbdefs\usbdefs_std_dsc.h
 *
 * Configuration information is defined in:
 * autofiles\usbcfg.h
 ********************************************************************/
 
/** I N C L U D E S *************************************************/
#include "system\typedefs.h"
#include "system\usb\usb.h"

/** C O N S T A N T S ************************************************/
#pragma romdata

/* Device Descriptor */
rom USB_DEV_DSC device_dsc=
{    
    sizeof(USB_DEV_DSC),    // Size of this descriptor in bytes
    DSC_DEV,                // DEVICE descriptor type
    0x0200,                 // USB Spec Release Number in BCD format
    0x00,                   // Class Code
    0x00,                   // Subclass code
    0x00,                   // Protocol code
    EP0_BUFF_SIZE,          // Max packet size for EP0, see usbcfg.h
    0x04D8,                 // Vendor ID = 1240
    0x0033,                 // Product ID = 51
    0x0001,                 // Device release number in BCD format
    0x01,                   // Manufacturer string index
    0x02,                   // Product string index
    0x03,                   // Device serial number string index
    0x02                    // Number of possible configurations
};

/* Configuration 1 Descriptor */
CFG01={
    /* Configuration Descriptor */
    sizeof(USB_CFG_DSC),    // Size of this descriptor in bytes
    DSC_CFG,                // CONFIGURATION descriptor type
    sizeof(cfg01),          // Total length of data for this cfg
    1,                      // Number of interfaces in this cfg
    1,                      // Index value of this configuration
    2,                      // Configuration string index
    _DEFAULT,               // Attributes, see usbdefs_std_dsc.h
    50,                     // Max power consumption (2X mA)

    /* Interface Descriptor */
    sizeof(USB_INTF_DSC),   // Size of this descriptor in bytes
    DSC_INTF,               // INTERFACE descriptor type
    0,                      // Interface Number
    0,                      // Alternate Setting Number
    2,                      // Number of endpoints in this intf
    HID_INTF,               // Class code
    0,                      // Subclass code
    0,                      // Protocol code
    0,                      // Interface string index

    /* HID Class-Specific Descriptor */
    sizeof(USB_HID_DSC),    // Size of this descriptor in bytes
    DSC_HID,                // HID descriptor type
    0x0001,                 // HID Spec Release Number in BCD format
    0x00,                   // Country Code (0x00 for Not supported)
    1,                      // Number of class descriptors, see usbcfg.h
    DSC_RPT,                // Report descriptor type
    sizeof(hid_rpt01),      // Size of the report descriptor

    /* Endpoint Descriptor 1 in */
    sizeof(USB_EP_DSC),
    DSC_EP,
    _EP01_IN,
    _INT,
    HID_INT_IN_EP_SIZE,
    0x01,

    /* Endpoint Descriptor 1 out */
    sizeof(USB_EP_DSC),
    DSC_EP,
    _EP01_OUT,
    _INT,
    HID_INT_OUT_EP_SIZE,
    0x01
};

rom struct{byte bLength;byte bDscType;word string[1];}sd000={
sizeof(sd000),DSC_STR,0x0409};

rom struct{byte bLength;byte bDscType;word string[25];}sd001={
sizeof(sd001),DSC_STR,
'M','i','c','r','o','c','h','i','p',' ','T','e','c','h','n','o','l','o','g','y',' ','I','n','c','.'};

rom struct{byte bLength;byte bDscType;word string[35];}sd002={
sizeof(sd002),DSC_STR,
'P','I','C','k','i','t',' ','2',' ','M','i','c','r','o','c','o','n','t','r','o','l','l','e','r',' ','P','r','o','g','r','a','m','m','e','r'};

rom struct{byte bLength;byte bDscType;word string[10];}sd003={
sizeof(sd003),DSC_STR,
'P','I','C','1','8','F','2','5','5','0'};

rom struct{byte report[HID_RPT01_SIZE];}hid_rpt01={
    0x06, 0x00, 0xFF,       //	Usage Page (Vendor Defined)
    0x09, 0x01,             //	Usage (Vendor Usage)
	0xA1, 0x01,             //	Collection (Application)
    0x85, 0x01,		//	Report ID=1   
    0x19, 0x01,             //	Usage Minimum (Vendor Usage = 1)
    0x29, 0x40,             //	Usage Maximum (Vendor Usage = 64)
    0x15, 0x00,             //	Logical Minimum (Vendor Usage = 0)
    0x26, 0xFF, 0x00,       //	Logical Maximum (Vendor Usage = 255)
    0x75, 0x08,             //	Report Size (Vendor Usage = 8)
    0x95, 0x3F,             //	Report Count (Vendor Usage = 63)
    0x81, 0x02,             //	Input (Data, Var, Abs)
    0x19, 0x01,             //	Usage Minimum (Vendor Usage = 1)
    0x29, 0x3F,             //	Usage Maximum (Vendor Usage = 63)
    0x91, 0x02,             //	Output (Data, Var, Ads)
    0xC0,                   //	End Collection
//
    0x05, 0x01,				//	Usage Page (Generic Desktop)
    0x09, 0x06,				//	Usage (Keyboard)
    0xA1, 0x01,				//	Collection (Application)
    0x85, 0x02,		//	Report ID = 2
    0x05, 0x07,				//	Usage (Key codes) 
    0x19, 0xE0,				//	Usage Minimum (224)
    0x29, 0xE7,				//	Usage Maximum (231)
    0x15, 0x00,				//	Logical Minimum (0)
    0x25, 0x01,				//	Logical Maximum (1)
    0x75, 0x01,				//	Report Size (1)
    0x95, 0x08,				//  Report Count (8)
    0x81, 0x02,				//	Input (Data, Variable, Absolute)
    0x95, 0x01,				//	Report Count (1)
    0x75, 0x08, 			//	Report Size (8)
    0x81, 0x01,				//	Input (Constant)    ;5 bit padding
    0x95, 0x05,				//	Report Count (5)
    0x75, 0x01,				//	Report Size (1)
    0x05, 0x08,				//	Usage Page (Page# for LEDs)
    0x19, 0x01,				//	Usage Minimum (01)
    0x29, 0x05,				//	Usage Maximum (05)
    0x91, 0x02,				//	Output (Data, Variable, Absolute)
    0x95, 0x01,				//	Report Count (1)
    0x75, 0x03,				//	Report Size (3)
    0x91, 0x01,				//	Output (Constant)
    0x95, 0x06,				//	Report Count (1)
    0x75, 0x08,				//	Report Size (3)
    0x15, 0x00,				//	Logical Minimum (0) 
    0x25, 0x65,				//	Logical Maximum (101)
    0x05, 0x07,				//	Usage (Key codes)
    0x19, 0x00,				//	Usage Minimum (00)
    0x29, 0x65,				//	Usage Maximum (101)
    0x81, 0x00,				//	Input (Data, Array)
    0xC0};					//	End Collection,End Collection


rom const unsigned char *rom USB_CD_Ptr[]={&cfg01,&cfg01};
rom const unsigned char *rom USB_SD_Ptr[]={&sd000,&sd001,&sd002,&sd003};

rom pFunc ClassReqHandler[1]=
{
    &USBCheckHIDRequest
};

#pragma code

/** EOF usbdsc.c ****************************************************/
