/*********************************************************************
 *
 *                Microchip USB C18 Firmware - Mouse Demo
 *
 *********************************************************************
 * FileName:        user_mouse.c
 * Dependencies:    See INCLUDES section below
 * Processor:       PIC18
 * Compiler:        C18 2.30.01+
 * Company:         Microchip Technology, Inc.
 *
 * Software License Agreement
 *
 * The software supplied herewith by Microchip Technology Incorporated
 * (the CompanyE for its PICmicro Microcontroller is intended and
 * supplied to you, the Companys customer, for use solely and
 * exclusively on Microchip PICmicro Microcontroller products. The
 * software is owned by the Company and/or its supplier, and is
 * protected under applicable copyright laws. All rights are reserved.
 * Any use in violation of the foregoing restrictions may subject the
 * user to criminal sanctions under applicable laws, as well as to
 * civil liability for the breach of the terms and conditions of this
 * license.
 *
 * THIS SOFTWARE IS PROVIDED IN AN AS ISECONDITION. NO WARRANTIES,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Rawin Rojvanit       11/19/04    Original.
 ********************************************************************/

/** I N C L U D E S **********************************************************/
#include <p18cxxx.h>
#include <usart.h>
#include "system\typedefs.h"

#include "system\usb\usb.h"

#include "io_cfg.h"             // I/O pin mapping
#include "user\user_mouse.h"

#include "delays.h"				//yts
#include "string.h"				//yts
/** V A R I A B L E S ********************************************************/
#pragma udata
/*
byte old_sw2,old_sw3;

BOOL emulate_mode;
rom signed char dir_table[]={-4,-4,-4, 0, 4, 4, 4, 0};
byte movement_length;
byte vector = 0;
*/
//buffer65Ƃ܂B
char buffer[65];

/** P R I V A T E  P R O T O T Y P E S ***************************************/
/*
void BlinkUSBStatus(void);
BOOL Switch2IsPressed(void);
BOOL Switch3IsPressed(void);

void Emulate_Mouse(void);
*/
void ClearBuffer(void);
/** D E C L A R A T I O N S **************************************************/
#pragma code
void UserInit(void)
{
/*
    mInitAllLEDs();
    mInitAllSwitches();
    old_sw2 = sw2;
    old_sw3 = sw3;

    buffer[0]=0;
    buffer[1]=0;
    buffer[2]=0;
    buffer[3]=0;
    
    emulate_mode = TRUE;
*/

}//end UserInit

/******************************************************************************
 * Function:        void ProcessIO(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This function is a place holder for other user routines.
 *                  It is a mixture of both USB and non-USB tasks.
 *
 * Note:            None
 *****************************************************************************/
void ProcessIO(void)
{ 
	char a,i;

    if((usb_device_state < CONFIGURED_STATE)||(UCONbits.SUSPND==1)) return;

// data transfer with HID class
    if (HIDRxReport(buffer, EP1_BUF_SIZE) > 0){ // USB receive buffer has data
		buffer[0]=1;//report ID=1
		buffer[1]+=1;
		while(mHIDTxIsBusy()){}                 // blocking
		HIDTxReport(buffer, EP1_BUF_SIZE);   // transmit packet
		return;
	}

// keyboard emulation
	else{
		a=PORTA & 0X7;
		i=0;
		while((a & 0x01)==1){
			i++;
			a=a>>1;
		}
		switch(i){
			case 0:
				Delay10KTCYx(25);	//50msec (in case of 20 MHz clock)
				if(PORTAbits.RA0!=0) return;
				buffer[0]=0x02;//report ID=2
				buffer[1]=0x00;buffer[2]=0x00;buffer[3]=0x1E;buffer[4]=0x16;
				buffer[5]=0x17;buffer[6]=0x28;buffer[7]=0x00;buffer[8]=0x00;
				//0x28 means a return key. This key is used for terminator, that is,
				// an application program recognizes the end of data with this key.
				break;
			case 1:
				Delay10KTCYx(25);
				if(PORTAbits.RA1!=0) return;
				buffer[0]=0x02;//report ID=2
				buffer[1]=0x00;buffer[2]=0x00;buffer[3]=0x1F;buffer[4]=0x11;
				buffer[5]=0x07;buffer[6]=0x28;buffer[7]=0x00;buffer[8]=0x00;
				break;
			case 2:
				Delay10KTCYx(25);
				if(PORTAbits.RA2!=0) return;
				buffer[0]=0x02;//report ID=2
				buffer[1]=0x00;buffer[2]=0x00;buffer[3]=0x20;buffer[4]=0x15;
				buffer[5]=0x07;buffer[6]=0x28;buffer[7]=0x00;buffer[8]=0x00;
				break;
			default: return;
		}

   		while(mHIDTxIsBusy()); HIDTxReport(buffer,9);
		ClearBuffer();
   		while(mHIDTxIsBusy()); HIDTxReport(buffer,9);

		while((PORTA & 0X07)!=0X07);
		return;
	}

}//end ProcessIO

void ClearBuffer(void)
{
	int i;
	for(i=1;i<9;i++) buffer[i]=0;
}
/** EOF user_mouse.c *********************************************************/
